#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <unistd.h>
#include <mxpclient.h>
#include <stralloc.h>
#include <sys/wait.h>
#include <afblib/hostport.h>
#include <afblib/ssystem.h>
#include <mxp.h>

int main (int argc, char** argv) {
   char* cmdname = *argv++; --argc;
   if (argc < 3) {
      fprintf(stderr, "Usage: %s hostport sema command\n", cmdname);
      exit(1);
   }
   char* hport = *argv++; --argc;
   char* sema = *argv++; --argc;

   hostport hp = {0};
   if (!parse_hostport(hport, &hp, MXP_PORT)) {
      perror(hport);
      exit(1);
   }
   int fd;
   if ((fd = socket(hp.domain, SOCK_STREAM, hp.protocol)) < 0) {
      perror("socket"); exit(1);
   }
   if (connect(fd, (struct sockaddr *) &hp.addr, hp.namelen) < 0) {
      perror(hport); exit(1);
   }

   struct mxpservice service = {0};
   mxp_init(&service, fd);
   
   stralloc login = {0};
   char* cp = getenv("USER"); if (cp) stralloc_copys(&login, cp);
   stralloc_cats(&login, "[");
   stralloc_catint(&login, getpid());
   stralloc_cats(&login, "]");
   char hostname[256];
   if (gethostname(hostname, sizeof hostname) == 0) {
      stralloc_cats(&login, "@");
      stralloc_cats(&login, hostname);
   }
   stralloc_0(&login);

   if (!mxp_login(&service, login.s)) {
      fprintf(stderr, "Unable to login to mutexd service\n");
      mxp_hangup(&service);
      exit(1);
   }

   if (!mxp_lock(&service, sema)) {
      fprintf(stderr, "Unable to get hold of semaphore %s\n", sema);
      mxp_hangup(&service);
      exit(1);
   }

   int stat = ssystem(argv);
   if (stat < 0) {
      perror(argv[0]);
   }

   if (!mxp_release(&service, sema)) {
      fprintf(stderr, "Unable to release semaphore %s\n", sema);
      mxp_hangup(&service);
      exit(1);
   }

   mxp_hangup(&service);

   if (stat == 0) exit(0);
   if (stat < 0 || !WIFEXITED(stat)) exit(255);
   exit(WEXITSTATUS(stat));
}
